#pragma once

/*
     Copyright (C) 2012 Tom Penk
     This program is free software; you can redistribute it and/or modify 
     it under the terms of the GNU General Public License version 2 as 
     published by the Free Software Foundation.
 
     This program is distributed in the hope that it will be useful, but 
     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
     or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
     for more details.
 
     You should have received a copy of the GNU General Public License along 
     with this program; if not, write to the Free Software Foundation, Inc., 
     51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#if !defined(AUDIOINPUTPIN_HMCENCODER_INCLUDED)
#define AUDIOINPUTPIN_HMCENCODER_INCLUDED

#include "HMCFilter.h"
#include "AsyncInputPin.h"

class AudioInputPin : public AsyncInputPin
{
	public:		AudioInputPin(HMCFilter * pFilter, CCritSec * pLock, HRESULT * phr);
				virtual ~AudioInputPin(void);
				
				//CBasePin
				HRESULT CheckMediaType(const CMediaType * pmt);

				//AsyncInputPin
				STDMETHODIMP EndOfStreamAsync(void);
				STDMETHODIMP ReceiveAsync(BYTE * buffer, long length);
};

#endif //AUDIOINPUTPIN_HMCENCODER_INCLUDED

